stages:
  - test
  - lint
  - deploy

sast:
  stage: test
include:
  - template: Security/SAST.gitlab-ci.yml

ruff:
  stage: lint
  image: python:3.12-alpine
  before_script:
    - pip install --no-cache ruff==0.1.8
  script:
    - ruff check --output-format=juint -o ruff_report.xml
  artifacts:
    when: always
    reports:
      junit: report.xml

ruff-format:
  stage: lint
  image: python:3.12-alpine
  before_script:
    - pip install --no-cache ruff==0.1.8
  script:
    - ruff format --check

pytest:
  stage: test
  image: python:3.12-alpine
  before_script:
    - pip install --no-cache pytest==7.4.3
  script:
    - pytest --junitxml=pytest_report.xml
  artifacts:
    when: always
    reports:
      junit: pytest_report.xml

test-pages:
  stage: test
  image: python:3.12-alpine
  before_script:
    - pip install --no-cache mkdocs==1.5.3 mkdocs-material==9.5.2 mkdocstrings==0.24.0
  script:
    - mkdocs build --strict --verbose --site-dir test

pages:
  stage: deploy
  image: python:3.12-alpine
  before_script:
    - pip install --no-cache mkdocs==1.5.3 mkdocs-material==9.5.2 mkdocstrings==0.24.0
  script:
    - mkdocs build --strict --verbose
  artifacts:
    paths:
      - public

docker-build:
  stage: deploy
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}"
